<template>
<div class="table-wrapper-scroll-y my-custom-scrollbar d-sm-flex justify-content-between">
    <table class="table table-bordered table-files"> 
        <thead id="head">                 
            <tr >
                <th >Nombre entidad</th>
                <th style="width:15%">Opciones</th>
                <th >Fecha registro</th>
                <th >Usuario</th>
            </tr>
        </thead>
        <tbody v-for="usuario in usuarios" :key="usuario.id_usuario">
            <tr  v-if="usuario.id_estado == 2">
                    <td>
                        <i class="fas fa-landmark"></i>
                        {{ usuario.data_usuario[0].nombre_entidad }}
                    </td>
                    <td>
                        <a 
                        @click="suspenderUsuario(usuario.id_usuario)"
                        data-toggle="tooltip" 
                        title="Suspender"
                        >
                            <i class="far fa-check-circle"></i> 
                        </a>
                        <a 
                        @click="rechazarUsuario(usuario.id_usuario)"
                        data-toggle="tooltip" 
                        title="Rechazar"
                        >
                            <i class="far fa-times-circle"></i> 
                        </a>
                        <a 
                        @click="editarUsuario(usuario)"
                        data-toggle="tooltip" 
                        title="Editar"
                        >
                            <i class="fas fa-user-edit"></i> 
                        </a>
                        <a 
                        @click="suspenderUsuario(usuario.id_usuario)"
                        data-toggle="tooltip" 
                        title="Suspender"
                        >
                            <i class="fas fa-user-slash"></i>
                        </a>
                    </td>
                    <td>
                        {{ moment(usuario.created_at).format('YYYY-MM-DD') }}
                    </td>
                    <td>
                        {{ usuario.nombres_usuario }} {{ usuario.apellidos_usuario }}
                    </td>
            </tr>
        </tbody>
    </table>
        <updateUsuario 
            :id_usuario="id_usuario"
            :nombres_usuario="nombres_usuario"
            :apellidos_usuario="apellidos_usuario"
            :documento_usuario="documento_usuario"
            :email_usuario="email_usuario"
            :telefono_usuario="telefono_usuario"
            :id_entidad="id_entidad"
            :nombre_entidad="nombre_entidad"
            :telefono_entidad="telefono_entidad"
            :direccion_entidad="direccion_entidad"
            :ruta="ruta"
            @datos-actualizados="postDatosActualizados()"
        />
</div>
</template>

<script>
import updateUsuario from '../udpateUsuario';
export default {
    props: ['ruta'],
    components: {
        updateUsuario
    },
    data() {
            return {
                url: document.head.querySelector('meta[name="url"]').content,
                usuarios: [],
                id_usuario: 0,
                nombres_usuario: '',
                apellidos_usuario: '',
                documento_usuario: '',
                email_usuario: '',
                telefono_usuario: '',
                id_entidad: '',
                nombre_entidad: '',
                telefono_entidad: '',
                direccion_entidad: ''
            }
        },
    created() {
        this.loadData();
    },
    methods: {
        loadData() {
            let url = this.url + '/api/get_usuarios';
            this.axios.get(url).then(response => {
                this.usuarios = response.data;
            });
        },
        suspenderUsuario(id) {
            let url = this.url + `/api/suspender/${id}`;
            this.axios.post(url).then(response => {
                if(response.status){
                    this.loadData();             
                    this.$utils.showWarning('Usuario actualizado',response.message);
                }else{
                    this.$utils.showSuccess('Error',response.message);
                }
            });
        },
        rechazarUsuario(id) {
            let url = this.url + `/api/eliminar/${id}`;
            this.axios.post(url).then(response => {
                if(response.status){
                    this.loadData();             
                    this.$utils.showWarning('Usuario actualizado',response.message);
                }else{
                    this.$utils.showSuccess('Error',response.message);
                }
            });
        },
        suspenderUsuario(id) {
            let url = this.url + `/api/suspender/${id}`;
            this.axios.post(url).then(response => {
                if(response.status){
                    this.loadData();             
                    this.$utils.showWarning('Usuario actualizado',response.message);
                }else{
                    this.$utils.showSuccess('Error',response.message);
                }
            });
        },
        async postDatosActualizados() {
            await this.loadData();
        },
        editarUsuario(data) {
            this.id_usuario = data.id_usuario;
            this.nombres_usuario = data.nombres_usuario;
            this.apellidos_usuario = data.apellidos_usuario;
            this.documento_usuario = data.cedula_usuario;
            this.email_usuario = data.email;
            this.telefono_usuario = data.telefono_usuario;
            this.id_entidad = data.id_entidad;
            this.nombre_entidad = data.data_usuario[0].nombre_entidad;
            this.telefono_entidad = data.data_usuario[0].telefono_entidad;
            this.direccion_entidad = data.data_usuario[0].direccion_entidad;
            this.$root.$emit("bv::toggle::modal", "updateDataUsuario");
            this.loadData();
        }
    }
}
</script>

<style>
.my-custom-scrollbar {
    position: relative;
    height: 387px;
    overflow: auto;
}
.table-wrapper-scroll-y {
    display: block;
}
#head th {
    position: sticky; 
    top: 0;
    z-index: 1;
    background:rgb(255, 255, 255);
}

</style>